package test;
import java.util.ArrayList;
import java.io.File;

public class Parser
{
	public final static String DEBUT_OPT="-";
	
	private String saLigneCmd=null;
	private int saLongueurLigneCmd=0;
	private ArrayList saListeOpt=null;
	
	
	public Parser(String telleLigneCmd)
	{
		saLigneCmd=telleLigneCmd;
		this.saLongueurLigneCmd=saLigneCmd.length();
		saListeOpt=new ArrayList();
	}
	
	public void addOption(int telLabel, String telleOption)
	{
		saListeOpt.add(new Option(telLabel, telleOption));
	}
	
	public Option[] getOptions()
	{
		Option[] lesOpt=new Option[saListeOpt.size()];
		
		for(int i=0; i<lesOpt.length; i++)
			lesOpt[i]=(Option)((Option)saListeOpt.get(i)).clone();
			
		return lesOpt;
	}
	
	public String getOption(int telLabel)
	{
		String leRet=null;
		boolean trouve=false;
		int laTaille=saListeOpt.size();
		
		for(int i=0; i<laTaille && !trouve; i++)
		{
			if(((Option)saListeOpt.get(i)).getLabel()==telLabel)
			{
				leRet=((Option)saListeOpt.get(i)).getOption();
				trouve=true;
			}
		}
		
		return leRet;
	}
	
	public void setLigneCmd(String telleLigneCmd)
	{
		saLigneCmd=telleLigneCmd;
		this.saLongueurLigneCmd=saLigneCmd.length();
	}
	
	public String getLigneCmd()
	{
		return saLigneCmd;
	}
	
	public boolean hasOption(String telleOption)
	{
		return saLigneCmd.indexOf(telleOption)!=-1;
	}
	
	public boolean hasOption(int telLabel)
	{
		String lOpt=getOption(telLabel);
		
		if(lOpt!=null)
			return hasOption(lOpt);
		else
			return false;
	}
	
	/**
	 * Retourne le paramtre d'une option de la ligne de commande si celle-ci existe!
	 * @param telleOpt L'option demande.
	 * @return La chaine correspondante.
	 */
	public String getParam(int telleOpt)
	{
		String lOpt=getOption(telleOpt);
		String leParam=null;
		
		if(hasOption(telleOpt))
		{
			int lIndex=saLigneCmd.indexOf(lOpt)+lOpt.length();
			
			if(lIndex<saLigneCmd.length())
				leParam=String.valueOf(saLigneCmd.charAt(lIndex++));
			else
				return null;
			
			int leNbGuillemets=0;
			
			for(int i=lIndex; i<saLongueurLigneCmd; i++)
			{
				if(saLigneCmd.charAt(i)=='"')
				{
					leNbGuillemets++;
				}
				else
				{
					if((saLigneCmd.charAt(i)==' ' && (leNbGuillemets==2 || leNbGuillemets==0)) || 
						(saLigneCmd.charAt(i)=='-' && (leNbGuillemets==2 || leNbGuillemets==0)) || 
						leNbGuillemets==2)
							break;
					else
						leParam+=String.valueOf(saLigneCmd.charAt(i));
				}
			}
			
			leParam=leParam.trim();
			
			if(leParam.length()==0)
				leParam=null;
		}
		
		return leParam;
	}
	
	public static String getLigneCmd(String[] telsArgv)
	{
		String laLigneCmd="";
		
		for(int i=0; i<telsArgv.length; i++)
		{
			if(telsArgv[i].startsWith("-") && telsArgv[i].length()==2)
				laLigneCmd+=telsArgv[i].trim()+" ";
			else
				laLigneCmd+="\""+telsArgv[i].trim()+"\" ";
		}
		
		return laLigneCmd.trim();
	}
	
	public class Option implements Cloneable
	{
		private int sonLabel;
		private String sonOption;
		
		public Option(int telLabel, String telleOption)
		{
			sonLabel=telLabel;
			sonOption=telleOption;
		}
		
		public int getLabel()
		{
			return sonLabel;
		}
		
		public String getOption()
		{
			return sonOption;
		}
		
		public Object clone()
		{
			return new Option(sonLabel, sonOption);
		}
	}
}