package test;
import java.io.File;
import util.ClearOrCompile;
import zip.VersionZip;

public class Test
{
	private static final String N_HELP=Parser.DEBUT_OPT+"h";
	private static final String N_SOURCE=Parser.DEBUT_OPT+"s";
	private static final String N_DESTINATION=Parser.DEBUT_OPT+"d";
	private static final String N_NOM=Parser.DEBUT_OPT+"n";
	private static final String N_COMPILE=Parser.DEBUT_OPT+"x";
	private static final String N_CLEAR=Parser.DEBUT_OPT+"c";
	private static final String N_ZIP=Parser.DEBUT_OPT+"z";
	
	private static final int ZIP=6;
	private static final int HELP=0;
	private static final int SOURCE=1;
	private static final int DESTINATION=2;
	private static final int NOM=3;
	private static final int COMPILE=4;
	private static final int CLEAR=5;
	private Parser sonParser=null;
	
	
	public static final String NOM_PROG="version";
	public static final String USAGE=
		"Usage: "+NOM_PROG+" options [-hzsdncx]\n"+
		"\t-h affiche cette aide\n"+
		"\t-z Creer une version du projet\n"+
		"\t-s repertoire_source\n"+
		"\t-d repertoire_destination\n"+
		"\t-n nom du projet (si aucun, dernier token du repertoire source)\n"+
		"\t-c genere un fichier clear permettant de nettoyer le projet\n"+
		"\t-x genere un fichier compile permettant de compiler le projet\n"+
		"\nExemple, creation d'une version du projet proj (proj.date.heure.zip):\n"+
		"\t"+NOM_PROG+" -z -s /home/user/projet -d /home/user/projet_saves -n proj\n"+
		"\nExemple, creation des fichiers de compilation et d'effacement:\n"+
		"\t"+NOM_PROG+" -x -c -s /home/user/projet";
	
	public static void main(String[] telsArgv)
	{
		/*
		Usage: version options [-hzsdncx]
        -h affiche cette aide
        -z Creer une version du projet
        -s repertoire_source
        -d repertoire_destination
        -n nom du projet (si aucun, dernier token du repertoire source)
        -c genere un fichier clear permettant de nettoyer le projet
        -x genere un fichier compile permettant de compiler le projet

		Exemple, creation d'une version du projet proj (proj.date.heure.zip):
		        version -z -s /home/user/projet -d /home/user/projet_saves -n proj
		
		Exemple, creation des fichiers de compilation et d'effacement:
		        version -x -c -s /home/user/projet
		*/
		
		//String laLigneCmd="version -s \"/home/fos-sar/projet maman\" -d \"/home/trouduq\"";
		Test leTest=new Test(Parser.getLigneCmd(telsArgv));
		leTest.traiteLigneCmd();
	}
	
	public Test(String telleLigneCmd)
	{
		creerLigneCmd(telleLigneCmd);
	}
	
	private void creerLigneCmd(String telleLigneCmd)
	{
		sonParser=new Parser(telleLigneCmd);
		sonParser.addOption(HELP, N_HELP);
		sonParser.addOption(SOURCE, N_SOURCE);
		sonParser.addOption(DESTINATION, N_DESTINATION);
		sonParser.addOption(NOM, N_NOM);
		sonParser.addOption(COMPILE, N_COMPILE);
		sonParser.addOption(CLEAR, N_CLEAR);
		sonParser.addOption(ZIP, N_ZIP);
	}
	
	
	public void traiteLigneCmd()
	{
		String laSource=null;
		String laDest=null;
		String leNom=null;
		
		boolean hasSource=sonParser.hasOption(SOURCE);
		boolean hasCompile=sonParser.hasOption(COMPILE);
		boolean hasClear=sonParser.hasOption(CLEAR);
		boolean hasZip=sonParser.hasOption(ZIP);
		
		
		if(sonParser.hasOption(HELP))
			System.out.println(test.Test.USAGE);
		
		
		if(hasSource)
		{
			laSource=sonParser.getParam(SOURCE);
			laDest=sonParser.getParam(DESTINATION);
			leNom=sonParser.getParam(NOM);
			
			if(laSource==null)
			{
				System.err.println("erreur, pas de param source");
				return;
			}
			
			if(laDest==null)
			{
				if(hasZip)
					System.err.println("Pas de destination, source est utilisee: "+laSource);
				
				laDest=laSource;
			}
				
			if(leNom==null)
			{
				leNom=util.Fichier.getLastToken(new File(laSource));
				
				if(hasZip)
					System.err.println("Pas de nom, le dernier token de la source est utilisee: "+leNom);
			}
		}
		

		if(hasCompile)
		{
			if(hasSource)
				ClearOrCompile.clearOrCompile(new File(laSource), util.Constantes.COMPILE);
			else
				System.err.println("Impossible de generer le fichier COMPILE - pas de source");
		}
		
		if(hasClear)
		{
			if(hasSource)
				ClearOrCompile.clearOrCompile(new File(laSource), util.Constantes.CLEAR);
			else
				System.err.println("Impossible de generer le fichier CLEAR - pas de source");
		}
		
		if(hasZip)
		{
			//creation du fichier zip
			if(hasSource)
				creerFichierZip(leNom, laSource, laDest);
			else
				System.err.println("Impossible de generer la version - pas de source");
		}
	}
	
	private void creerFichierZip(String telNom, String telleSource, String telleDestination)
	{
		VersionZip laVZ=new VersionZip(telleSource, telleDestination, telNom);
		//File leFichierSource=new File(telleSource);
		//String leRepBase=util.Fichier.getLastToken(leFichierSource);
		
		creerZipEntry(telleSource, laVZ);
		laVZ.enregistrer();
	}
	
	private void creerZipEntry(String telRep, VersionZip telZip)
	{
		//on creer tous les zip entry des fichiers de ce repertoire
		File[] lesFichiers=util.Fichier.getAllFile(telRep);
		for(int i=0; i<lesFichiers.length; i++)
		{
			telZip.ajouter(lesFichiers[i]);
		}
		
		//on rappelle sur tous les sous repertoire
		File[] lesRepertoires=util.Fichier.getAllDirectory(telRep);
		for(int i=0; i<lesRepertoires.length; i++)
			creerZipEntry(lesRepertoires[i].getPath(), telZip);
	}
}