package util;
import java.io.File;
import java.util.StringTokenizer;
import java.util.ArrayList;

public class ClearOrCompile
{
	private static String sonContenu;
	private static final String DEBUT_CONTENU="@echo off"+Constantes.ENDL;
	private static String sonPathPrecedent=null;
	
	public static void clearOrCompile(File telRep, int telleCmd)
	{
		sonContenu=DEBUT_CONTENU;
		sonPathPrecedent=telRep.getPath();
		
		clearOrCompileInterne(telRep, telleCmd);
		enregistrer(telRep, telleCmd);
	}
	
	private static void clearOrCompileInterne(File telRep, int telleCmd)
	{
		String leFichierExecutable=null;
		
		switch(telleCmd)
		{
			case Constantes.CLEAR:
				leFichierExecutable=Constantes.CLEAR_EXE;
				break;
				
			case Constantes.COMPILE:
				leFichierExecutable=Constantes.COMPILE_EXE;
				break;
		}
		
		if(leFichierExecutable!=null)
		{
			File leF=new File(telRep.getPath()+telRep.separator+leFichierExecutable);
			
			if(leF.exists() && leF.isFile())
			{
				if(telRep.isDirectory())
				{
					if(sonPathPrecedent!=null)
						cdRep(new File(sonPathPrecedent), telRep);
					else
						cdRep(null, telRep);
				}
				
				String[] lesCmd = Fichier.getCmd(leF);
				
				for(int i=0; i<lesCmd.length; i++)
				{
					sonContenu+=lesCmd[i]+Constantes.ENDL;
				}
			}
		}
	}
	
	private static void enregistrer(File telRep, int telleCmd)
	{
		File[] lesF = Fichier.getAllDirectory(telRep.getPath());
		
		for(int i=0; i<lesF.length; i++)
		{
			clearOrCompileInDirectoryRecursif(lesF[i], telleCmd);
		}
		
		if(sonPathPrecedent!=null)
			cdRep(new File(sonPathPrecedent), telRep);
		else
			cdRep(null, telRep);
		
		switch(telleCmd)
		{
			case Constantes.CLEAR:
				Fichier.genereFichier(telRep.getPath()+telRep.separator+Constantes.NOM_CLEARALL, sonContenu);
				break;
				
			case Constantes.COMPILE:
				Fichier.genereFichier(telRep.getPath()+telRep.separator+Constantes.NOM_COMPILEALL, sonContenu);
				break;
		}
	}
	
	private static void clearOrCompileInDirectoryRecursif(File telRep, int telleCmd)
	{
		clearOrCompileInterne(telRep, telleCmd);
		
		File[] lesF = null;
		lesF = Fichier.getAllDirectory(telRep.getPath());
		
		for(int i=0; i<lesF.length; i++)
			clearOrCompileInDirectoryRecursif(lesF[i], telleCmd);
	}
	
	private static void cdRep(File telRepSource, File telRepDest)
	{
		sonPathPrecedent=telRepDest.getPath();
		
		if(telRepSource==null)
			telRepSource=telRepDest;
		
		StringTokenizer leTokS=new StringTokenizer(telRepSource.getPath(), telRepSource.separator);
		StringTokenizer leTokD=new StringTokenizer(telRepDest.getPath(), telRepDest.separator);
		int leNbTokS=leTokS.countTokens();
		int leNbTokD=leTokD.countTokens();
			
		if(leNbTokS==leNbTokD)
		{
			if(telRepSource.getPath().equals(telRepDest.getPath()))
			{
				return;
			}
			else
			{
				ArrayList lesRep=new ArrayList();
				
				while(leTokD.hasMoreTokens())
				{
					String laCS=leTokS.nextToken();
					String laCD=leTokD.nextToken();
					
					if(!laCS.equals(laCD))
					{
						lesRep.add(laCD);
						sonContenu+="cd .."+Constantes.ENDL;
					}
				}
				
				int laTaille=lesRep.size();
				for(int i=0; i<laTaille; i++)
					sonContenu+="cd \""+(String)lesRep.get(i)+"\""+Constantes.ENDL;
			}
		}
		else
		{
			if(leNbTokS>leNbTokD)
			{
				ArrayList lesRep=new ArrayList();
				
				while(leTokS.hasMoreTokens())
				{
					String laCD="";
					
					if(leTokD.hasMoreTokens())
						laCD=leTokD.nextToken();
					
					String laCS=leTokS.nextToken();
					
					if(!laCS.equals(laCD))
					{
						if(!laCD.equals(""))
							lesRep.add(laCD);
						
						sonContenu+="cd .."+Constantes.ENDL;
					}
				}
				
				int laTaille=lesRep.size();
				for(int i=0; i<laTaille; i++)
					sonContenu+="cd \""+(String)lesRep.get(i)+"\""+Constantes.ENDL;
			}
			else
			{
				ArrayList lesRep=new ArrayList();
				
				while(leTokD.hasMoreTokens())
				{
					String laCS="";
					
					if(leTokS.hasMoreTokens())
						laCS=leTokS.nextToken();
					
					String laCD=leTokD.nextToken();
					
					if(!laCS.equals(laCD))
					{
						if(!laCS.equals(""))
							sonContenu+="cd .."+Constantes.ENDL;
						
						lesRep.add(laCD);
					}
				}
				
				int laTaille=lesRep.size();
				for(int i=0; i<laTaille; i++)
					sonContenu+="cd \""+(String)lesRep.get(i)+"\""+Constantes.ENDL;
			}
		}
	}
	

}