package util;
import java.io.File;
import java.io.IOException;
import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.FileOutputStream;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class Fichier
{
	private final static int REPERTOIRE=0;
	private final static int FICHIER=1;
	
	public static File[] getAllDirectory(String telRep)
	{
		return getAll(telRep, REPERTOIRE);
	}
	
	public static File[] getAllFile(String telRep)
	{
		return getAll(telRep, FICHIER);
	}
	
	private static File[] getAll(String telRep, int telType)
	{
		File[] lesRep=null;
		ArrayList lesRep2=new ArrayList();
		
		File leF=new File(telRep);
		lesRep=leF.listFiles();
		
		int j=0;
		for(int i=0; i<lesRep.length; i++)
		{
			switch(telType)
			{
				case REPERTOIRE:
					if(lesRep[i].isDirectory())
						lesRep2.add(lesRep[i]);
					break;
				
				case FICHIER:
					if(lesRep[i].isFile())
						lesRep2.add(lesRep[i]);
					break;
					
			}
		}
		
		lesRep=new File[lesRep2.size()];
		for(int i=0; i<lesRep.length; i++)
			lesRep[i]=(File)lesRep2.get(i);
			
		return lesRep;
	}
	
	public static String[] getCmd(File telFichier)
	{
		String[] lesCmd=null;
		ArrayList laListeCmd=new ArrayList();
		
		try
		{
			BufferedReader leFlux=new BufferedReader(new InputStreamReader(new FileInputStream(telFichier)));
			
			String laCmd="";
			while((laCmd = leFlux.readLine())!=null)
				if(laCmd.length()!=0)
					laListeCmd.add(laCmd);
					
			leFlux.close();
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}
		
		lesCmd=new String[laListeCmd.size()];
		for(int i=0; i<lesCmd.length; i++)
			lesCmd[i]=(String)laListeCmd.get(i);
		
		return lesCmd;
	}
	
	public static String getLastToken(File telRep)
	{
		String lePath=telRep.getPath();
		StringTokenizer leTok=new StringTokenizer(lePath, telRep.separator);
		String leDernier=null;
		int leNbTok=leTok.countTokens();
		
		for(int i=0; i<leNbTok; i++)
			leDernier=leTok.nextToken();
		
		return leDernier;
	}
	
	public static void genereFichier(String telFichier, String telContenu)
	{
		File leFichier=new File(telFichier);
		
		try
		{
			if(leFichier.exists() && leFichier.isFile())
			{
				leFichier.delete();
			}
			
			PrintWriter leFlux=new PrintWriter(new FileOutputStream(telFichier));
			
			leFlux.write(telContenu);
			leFlux.flush();
			leFlux.close();
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}
	}
	
	public static File formatFileForZip(File telFichier, String telNomRepBase)
	{
		String leRep=null;
		String lePath=telFichier.getPath();
		int lIndex=lePath.indexOf(telNomRepBase);
		
		if(lIndex!=-1)
			leRep=lePath.substring(lIndex, lePath.length());
			
		
		return new File(leRep);
	}
	
	public static File getPathBeforeRepBase(File telFichier, String telNomRepBase)
	{
		String leRep=null;
		String lePath=telFichier.getPath();
		int lIndex=lePath.indexOf(telNomRepBase);
		leRep=lePath.substring(0, lIndex);
		
		return new File(leRep);
	}
}