package zip;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.zip.*;
import java.io.*;

public class VersionZip
{
	private FileOutputStream sonF;
	private ZipOutputStream sonZ;
	private ArrayList saListe=null;
	private File sonZip=null;
	private String sonPathBeforeBase=null;
	private String saBase=null;
	private String sonRepDest=null;
	public static final int TAILLE_TAB_BYTE=4096;
	public static final String INTERN_SEPARATOR="-";
	public static final String EXTERN_SEPARATOR=".";
	public static final String EXTENSION=".zip";
	
	public VersionZip(String telRepSource, String telRepDest, String telNomProjet) throws RuntimeException
	{
		File leFichierSource=new File(telRepSource);
		saBase=util.Fichier.getLastToken(leFichierSource);
		sonPathBeforeBase=util.Fichier.getPathBeforeRepBase(leFichierSource, saBase).getPath();
		sonRepDest=telRepDest;
		
		File leTemoin=new File(".");
		
		//on enleve un eventuelle / ou \ a la fin de telRepSource
		if(String.valueOf(telRepSource.charAt(telRepSource.length()-1)).equals(leTemoin.separator))
			telRepSource=telRepSource.substring(0, telRepSource.length()-2);
		
		sonZip=new File(telRepDest+leTemoin.separator+getVersionName(telNomProjet));
	}
	
	public void ajouter(File f) throws RuntimeException
	{
		if(f.getPath().indexOf(sonPathBeforeBase)==-1)
			throw new RuntimeException("Ne peut ajouter le fichier - la source est introuvable");
		
		File leFichier=new File(util.Fichier.formatFileForZip(f, saBase).getPath());
		
		if(saListe==null)
			saListe=new ArrayList();
		
		saListe.add(new ZipEntry(leFichier.getPath()));
	}	
	
	public void enregistrer()
	{
		int laTaille=saListe.size();
		FileInputStream leF;
		File leTemoin=new File(".");
		
		try
		{
			sonF=new FileOutputStream(sonZip);
			sonZ=new ZipOutputStream(sonF);
			
			
			for(int i=0; i<laTaille; i++)
			{
				byte[] leTabByte=new byte[TAILLE_TAB_BYTE];
				ZipEntry ze=(ZipEntry)saListe.get(i);
				int lOffset=0;
				int leNbByteLus=0;
				
				leF=new FileInputStream(sonPathBeforeBase+leTemoin.separator+ze.getName());
				sonZ.putNextEntry(ze);
				
				while((leNbByteLus=leF.read(leTabByte))>0)
				{
					sonZ.write(leTabByte, 0, leNbByteLus);
					lOffset+=leNbByteLus;
				}
				
				sonZ.closeEntry();
				leF.close();
			}//for
			
			sonZ.flush();
			sonZ.close();
			sonF.close();
			
		}
		catch(IOException ioe)
		{
			ioe.printStackTrace();
		}
	}
	
	
	public static String getVersionName(String telNomProjet)
	{
		//nom de la forme nomProjet.date.heure.zip sans espaces!
		
		/*
		 * On remplace les espaces par des _
		 */
		int laLongueur=telNomProjet.length();
		String leNom="";
		
		for(int i=0; i<laLongueur; i++)
		{
			char leC=telNomProjet.charAt(i);
			if(leC==' ')
				leNom+="_";
			else
				leNom+=leC;
		}
		
		
		
		leNom+=EXTERN_SEPARATOR+getDateHeure()+EXTENSION;
		return leNom;
	}
	
	private static String getDateHeure()
	{
		//date du jour
		Calendar leC=Calendar.getInstance();
		String leRet;
		String leJour;
		String leMois;
		String lAnnee;
		String lHeure;
		String laMinute;
		
		leJour=formatForDate(leC.get(Calendar.DAY_OF_MONTH));
		leMois=formatForDate(leC.get(Calendar.MONTH)+1);
		lAnnee=formatForDate(leC.get(Calendar.YEAR));
		lHeure=formatForDate(leC.get(Calendar.HOUR_OF_DAY));
		laMinute=formatForDate(leC.get(Calendar.MINUTE));
		
		return 	leJour+INTERN_SEPARATOR+
				leMois+INTERN_SEPARATOR+
				lAnnee+EXTERN_SEPARATOR+
				lHeure+INTERN_SEPARATOR+
				laMinute;
	}
	
	private static String formatForDate(int telNb)
	{
		String leRet=String.valueOf(telNb);
		int laLong=leRet.length();
		
		if(laLong==2)
		{
			return leRet;
		}
		else
		{
			if(laLong==4)
			{
				return formatForDate(telNb%100);
			}
			else
			{
				//On ajoute un 0 devant
				leRet="0"+String.valueOf(telNb);
			}
		}
		
		return leRet;
	}
}
